// STOPPER - TIMER

#include <time.h>
#include <conio.h>

#define NULL 0

class CLOCK{
   time_t starttime;	// objekti loomise aeg - time creating object
   int h;		// tunnid - hours
   int m;		// minutid - minutes
   int s;		// sekundid - seconds
   void correcttime(void);
   void converttime(time_t);

public:
   CLOCK(void) {h=m=s=0; starttime=time(NULL);}
	// objekti 'CLOCK' konstruktor - constructor of object class 'CLOCK'
   void print();
   void nulli();
};

void CLOCK::correcttime(void)
{
   while(s>=60){m++; s-=60;} // sekundid ja minutid vahemikus 0...59
   while(m>=60){h++; m-=60;} // seconds and minutes between 0...59
   while(h>=24)h-=24;	     // tunnid vahemikus 0...23
}

void CLOCK::converttime(time_t now)
	// teisendab aja sekundites tundideks, minutiteks ja sekunditeks
	// converts time in seconds to hours, minutes and seconds
{
   h=m=0;
   while(now>5*3600){h+=5;now-=18000;}
   s=(int)now;
   correcttime();
}

void CLOCK::print(void)
{
    time_t timediff;
    timediff=time(NULL)-starttime;
    converttime(timediff);
    cprintf("%02d:%02d:%02d",h,m,s);
}

void CLOCK::nulli(void)
{
 h=m=s=0;
 starttime=time(NULL);
}

int main(void)
{
   CLOCK clock;
   clrscr();
   _setcursortype(_NOCURSOR);
   gotoxy(1,24);
   cprintf("Press 'Esc' to exit program");
   while(1){
      gotoxy(30,5); clock.print();
      if(kbhit())
	 {char c=getch();
	  if(c==0x1b)break;
            else clock.nulli();} // Esc
   }
   _setcursortype(_NORMALCURSOR);
   return 0;
}

