/***************************************************************
 HIIR_TM.H     1997.V.     Ain Valtin
  Fail sisaldab makrosid hiirega ttamiseks teksti ekraanil:
   INST_HIIR - "installeerib" hiire
   NAITA_HIIR - teeb hiirekursori nhtavaks
   PEIDA_HIIR - peidab hiirekursori
   KUS_HIIR - parameetrid :
      (1) - kui hiire nuppe ei ole vajutatud vrtus 0
	  - kui on vajutatud hiire parempoolset nuppu vrtus 1
	  - kui on vajutatud hiire vasakpoolset nuppu vrtus 2
	  - kui on vajutatud keskmist nuppu vrtus 4
      (2) - hiirekursori horisontaalne positsioon
      (3) - hiirekursori vertikaalne positsioon
      !! koordinaadid on ekraani 1,1,80,25 suhtes !!
   VII_HIIR - viib hiirekursori etteantud positsioonile, parameetrid:
      (1) - soovitav horisontaalne positsioon
      (2) - soovitav vertikaalne positsioon
      !! koordinaadid on ekraani 1,1,80,25 suhtes !!

   HIIR - n. abimakro, annab ssteemile ksu tita vastav hiire
     funktsioon, parameetriks tidetava funktsiooni number
 **************************************************************/

#if !defined(__HIIR_TM_H) && !defined(__HIIR_H)
 #define __HIIR_TM_H

 #define HIIR(arg) _AX = arg; asm int 0x33;

 #define INST_HIIR HIIR(0) NAITA_HIIR

 #define VII_HIIR(hr,vr) _CX=(hr-1)*8; _DX=(vr-1)*8; HIIR(4)

 #define NAITA_HIIR HIIR(1)

 #define PEIDA_HIIR HIIR(2)

 #define KUS_HIIR(pr,hr,vr) HIIR(3); pr=_BX; hr=_CX/8+1; vr=_DX/8+1;


#endif //__HIIR_TM_H

/*  ** NIDE **

#include <conio.h>
#include <stdio.h>
#include <dos.h>

void main(void){
  int press,hor,ver,xx;
   clrscr();
   _setcursortype(_NOCURSOR);
   INST_HIIR
   VII_HIIR(10,10);
   while(xx!=13){
      KUS_HIIR(press,hor,ver);
      if(press){
	if(press==1){gotoxy(20,1);printf("parem   ");}
	else if(press==2){gotoxy(20,1);printf("vasak   ");}
	else {gotoxy(20,1);printf("%d",press);}
      }
      gotoxy(1,1);
      printf(" %d,%d ",hor,ver);
      if(kbhit())xx=getch();
    }
    PEIDA_HIIR
return;}
*/